#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <utility>

using namespace std;

typedef map<string, int> msi;

void fA() {
  int n, m;
  cin >> n >> m;
  if (n - 7 >= 1)
      cout << n - 7;
  else
      cout << m + 7;
}

int64_t count_bits(int64_t n)
{
    int64_t res {0};

    for (int64_t i {0}; i < 0x40; i++)
        res += (n >> i) & 1;

    return res;
}

int64_t up_to_pow2(int64_t n)
{
    int64_t up {n};
    up |= (up >> 0x1);
    up |= (up >> 0x2);
    up |= (up >> 0x4);
    up |= (up >> 0x8);
    up |= (up >> 0x10);
    up |= (up >> 0x20);

    up = (up ^ (up >> 1)) << 1;

    return up;
}

void fE()
{
    int64_t n;
    cin >> n;

    while (n-- > 0)
    {
        int64_t Val;

        cin >> Val;

        Val = abs(Val);

        int64_t Res {0}, Cur {0};

        while (Cur != Val)
        {
            if (Cur < Val)
            {
                int64_t len_up {up_to_pow2(Val - Cur)};
                int64_t len_down {len_up >> 1};

                int64_t Cur1 {Cur + len_down};
                int64_t Cur2 {Cur + len_up};

                if (abs(Cur1 - Val) < abs(Cur2 - Val))
                    Cur = Cur1;
                else
                    Cur = Cur2;
            }
            else
            {
                int64_t len_up {up_to_pow2(Cur - Val)};
                int64_t len_down {len_up >> 1};

                int64_t Cur1 {Cur - len_down};
                int64_t Cur2 {Cur - len_up};

                if (abs(Cur1 - Val) < abs(Cur2 - Val))
                    Cur = Cur1;
                else
                    Cur = Cur2;
            }

            Res++;
        }

        cout << Res << "\n";
    }
}
/* 6 3 1 2 L 2 LL 1 0 LL 2 LLR 2 LR 2 R */

void fD() {
    int q, c;
    cin >> q >> c;
    string aim;
    msi newcolor;
    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            cin >> aim;
            newcolor[aim] = x;
        } else {
            cin >> aim;
			string pos = "";
            int curcolor = -1;
            bool isColor = false;

            for (int j = 0; j < aim.size(); j++) {
                pos += aim[j];
                auto it = newcolor.find(pos);
                if (isColor) {
                    if (aim[j] == 'L')
                        curcolor = (curcolor + 1) % c;
                    else
                        curcolor = (curcolor - 1 + c) % c;
                }
                if (it != newcolor.cend()) {
                    curcolor = it->second;
                    isColor = true;
                }
            }
            cout << curcolor << endl;
        }
    }
}

void fC() {
    int n, sum = 0, i = 0;
    cin >> n;
    while (n > 0) {
        n -= ++i;
    }
    n += i;
    i -= !!n;
    for (; i > 0; i--) {
        if (n > 0) {
            sum += i * (i + 1);
            n--;
        } else
            sum += i * (i - 1);
    }
    cout << sum / 2;
}

int main() {
    fC();
    return 0;
}
