#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#define Int int
#define all(x) x.begin, x.end()
#define ll long long

using namespace std;

void print(vector<int> a) {
	for (int i = 0; i < a.size(); ++i) {
		cout << a[i] << ' ';
	}
	cout << '\n';
}

struct tree {
	vector<int> t;
	int n;

	void build(int v, int l, int r, vector<int> a) {
		if (l + 1 == r) {
			t[v] = a[l];
			return;
		}
		int m = (l + r) / 2;
		build(2 * v + 1, l, m, a);
		build(2 * v + 2, m, r, a);
		t[v] = t[2 * v + 1] + t[2 * v + 2];
	}

	tree(vector<int> a) {
		n = a.size();
		t.resize(4 * n);
		build(0, 0, n, a);
		print(t);
	}

	void change(int ind, int val, int l, int r, int v) {
		if (ind >= r || l > ind) {
			return;
		}
		if (l + 1 == r) {
			t[v] = val;
			return;
		}
		int m = (l + r) / 2;
		change(ind, val, l, m, 2 * v + 1);
		change(ind, val, m, r, 2 * v + 2);
	}

	void change(int ind, int val) {
		change(ind, val, 0, n, 0);
	}

	ll sum(int v, int ql, int qr, int l, int r) {
		if (qr <= l || r <= ql) {
			return 0;
		}
		if (l <= ql || qr <= r) {
			return t[v];
		}
		int m = (l + r) / 2;
		return sum(2 * v + 1, ql, m, l, r) + sum(2 * v + 2, m, qr, l, r);
	}

	ll sum(int l, int r) {
		return sum(0, 0, n, l, r);
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	tree t(a);
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int typ, l, r;
		cin >> typ >> l >> r;
		if (typ) {
			cout << t.sum(l - 1, r) << '\n';
		}
		else {
			t.change(l - 1, r);
		}
	}
}