#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#define Int int
#define all(x) x.begin, x.end()
#define ll long long

using namespace std;

void print(vector<int> a) {
	for (int i = 0; i < a.size(); ++i) {
		cout << a[i] << ' ';
	}
	cout << '\n';
}

struct tree {
	vector<int> t;
	int n;

	void build(int v, int l, int r, vector<int> a) {
		if (l + 1 == r) {
			t[v] = a[l];
			return;
		}
		int m = (l + r) / 2;
		build(2 * v + 1, l, m, a);
		build(2 * v + 2, m, r, a);
		t[v] = min(t[2 * v + 1], t[2 * v + 2]);
	}

	tree(vector<int> a) {
		n = a.size();
		t.resize(4 * n);
		build(0, 0, n, a);
		//print(t);
	}

	void change(int ind, int val, int l, int r, int v) {
		if (ind >= r || l > ind) {
			return;
		}
		if (l + 1 == r) {
			t[v] = val;
			return;
		}
		int m = (l + r) / 2;
		change(ind, val, l, m, 2 * v + 1);
		change(ind, val, m, r, 2 * v + 2);
		t[v] = t[2 * v + 1] + t[2 * v + 2];
	}

	void change(int ind, int val) {
		change(ind, val, 0, n, 0);
	}

	int sum(int v, int ql, int qr, int l, int r) {
		if (qr <= l || r <= ql) {
			return 1e9;
		}
		if (l <= ql && qr <= r) {
			return t[v];
		}
		int m = (ql + qr) / 2;
		return min(sum(2 * v + 1, ql, m, l, r), sum(2 * v + 2, m, qr, l, r));
	}

	int sum(int l, int r) {
		return sum(0, 0, n, l, r);
	}
};

ll max(ll a, ll b) {
	return (a > b ? a : b);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	cin >> n;
	vector<ll> pref(n + 1, 0);
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		int el;
		cin >> el;
		a[i] = el;
		pref[i + 1] = pref[i] + el;
	}
	ll targ = (pref[n] + 1) / 2;
	int l = 0, r = n;
	tree t(a);
	int mmax, mmaxind;
	while (l + 1 != r) {
		int m = (l + r) / 2;
		mmax = 0;
		mmaxind = 0;
		bool fl = false;
		for (int i = m; i <= n; ++i) {
			ll el = pref[i] - pref[i - m];
			if (el > mmax) {
				mmax = el;
				mmaxind = i;
			}
		}
		if (mmax >= targ) {
			r = m;
		}
		else {
			l = m;
		}
	}
	if (pref[mmaxind] - pref[mmaxind - r] - t.sum(mmaxind - r - 1, mmaxind) >= targ) {
		cout << l << '\n';
	}
	else {
		cout << r;
	}
}