#include<bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

const ld EPS = 1e-8;

using vec = pair<ll, ll>;

#define x first
#define y second
#define ff first
#define ss second
#define all(x) x.begin(), x.end()

#define int ll

vec operator-(vec a, vec b) {
    return {a.x - b.x, a.y - b.y};
}

ll cross_prod(vec a, vec b) {
    return a.x * b.y - a.y * b.x;
}

int cross_sign(vec a, vec b) {
    ll x = cross_prod(a, b);
    if (x < 0) return -1;
    if (x > 0) return 1;
    return 0;
}

ll dot_prod(vec a, vec b) {
    return a.x * b.x + a.y * b.y;
}

int dot_sign(vec a, vec b) {
    ll x = dot_prod(a, b);
    if (x < 0) return -1;
    if (x > 0) return 1;
    return 0;
}

bool check(vec a, vec b, vec c) {
    return cross_prod(b - a, c - a) == 0;
}

bool on_seg(vec a, vec b, vec c) {
    return check(a, b, c) && dot_sign(b - a, c - a) * dot_sign(a - b, c - b) >= 0;
}

bool cross(vec a, vec b, vec c, vec d) {
    if (cross_prod(b - a, d - c) == 0 && cross_prod(b - a, c - a) == 0) {
        return on_seg(a, b, c) || on_seg(a, b, d) || on_seg(c, d, a) || on_seg(c, d, b);
    }
    return cross_sign(c - d, a - d) * cross_sign(c - d, b - d) <= 0 && cross_sign(a - b, c - b) * cross_sign(a - b, d - b) <= 0;
}

ld len(vec a) {
    return sqrtl(a.x * a.x + a.y * a.y);
}

struct line {
    ll a, b, c;

    line() {}
    line(vec v1, vec v2) {
        a = v1.y - v2.y;
        b = v2.x - v1.x;
        c = -v1.x * a - v1.y * b;
    }
};

ld dist(line l, vec a) {
    return abs(a.x * l.a + a.y * l.b + l.c) / sqrtl(l.a * l.a + l.b * l.b);
}

ld dist(vec a, vec b, vec c) {
    if (dot_prod(c - a, b - a) > 0 && dot_prod(c - b, a - b) > 0) {
        return dist(line(a, b), c);
    }
    return min(len(a - c), len(b - c));
}

ld dist(vec a, vec b, vec c, vec d) {
    return min({
        dist(a, b, c),
        dist(a, b, d),
        dist(c, d, a),
        dist(c, d, b)
    });
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<pair<vec, vec>> a(n);
    for (auto& i : a) cin >> i.ff.x >> i.ff.y >> i.ss.x >> i.ss.y;
    int ans = 0;
    for (int i = 0; i < n; ++i){
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                bool ok = 0;
                vector<pair<vec, vec>> b = {a[i], a[j], a[k]};
                sort(all(b));
                do {
                    if (cross(b[0].ff, b[0].ss, b[1].ff, b[1].ss)) ok = 1;
                } while (next_permutation(all(b)));
                sort(all(b));
                do {
                    if (dist(b[0].ff, b[0].ss, b[1].ff, b[1].ss) <= EPS + len(b[2].ff - b[2].ss)) ok = 1;
               } while (next_permutation(all(b)));
                ans += ok;
            }
        }
    }
    cout << ans;
}