#define _USE_MATH_CONSTANTS
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <array>
#include <list>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <utility>
#include <tuple>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using vi = std::vector<int>;
using vvi = std::vector<vi>;
using vb = std::vector<bool>;
using vvb = std::vector<vb>;
using pii = pair<int, int>;


#define all(c) (c).begin(), (c).end()
#define mk make_pair
#define pb push_back

ll euclid(ll a, ll b)
{
	if (a < b)
		swap(a, b);
	if (a % b == 0)
		return b;
	return euclid(a % b, b);
}

template<class _ty>
auto qpow(_ty a, ull pw)
{
	_ty res = 1;
	for (ull _pw = (1ull << 63); _pw > 0; _pw >>= 1)
	{
		res *= res;
		if (_pw & pw)
		{
			res *= a;
		}
	}
	return res;
}

constexpr int maxn = int(2e5);


namespace sgtree
{
	ll tree[maxn * 2];

	constexpr ll NEUTRAL = INT_MAX;

	int nn;

	auto combine = [](ll a, ll b) { return min(a, b); };

	void init(const vector<ll>& arr)
	{
		nn = arr.size();
		for (int i = nn; i < nn * 2; ++i)
		{
			tree[i] = arr[i - nn];
		}
	}

	void build(const vector<ll>& arr)
	{
		init(arr);
		for (int i = nn - 1; i >= 0; --i)
		{
			tree[i] = combine(tree[i << 1], tree[i << 1 | 1]);
		}
	}

	/*
	void set(int p)
	{
		for (p += nn; p > 1; p >>= 1)
		{
			tree[p << 1] = combine(tree[p], tree[p ^ 1]);
		}
	}
	*/

	ll get(int l, int r)
	{
		ll res = NEUTRAL;
		for (l += nn, r += nn; r > l; l >>= 1, r >>= 1)
		{
			if (l & 1) res = combine(res, tree[l++]);
			if (r & 1) res = combine(res, tree[--r]);
		}
		return res;
	}
}

//using namespace sgtree;

int n, m;

bool ok(int x, int y)
{
	return ((x >= 0) && (y >= 0) && (x < n) && (y < m));
}

vvi arr;

void solve()
{
	cin >> n >> m;
	arr.resize(n);
	for (int i = 0; i < n; ++i)
	{
		arr[i].resize(m);
		for (int j = 0; j < m; ++j)
		{
			cin >> arr[i][j];
		}
	}
	bool d1 = false;
	bool d2 = false;
	int diag1 = n + m + 1;
	int diag2 = n + m + 1;
	int compx, compy;
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			if (arr[i][j] % 4 == 0)
			{
				d1 = true;
				diag1 = i - j;
				compx = i;
				compy = j;
			}
			else if (arr[i][j] % 2 == 0)
			{
				d2 = true;
				diag2 = i + j;
				compx = i;
				compy = j;
			}
		}
	}

	if (d1 && d2)
	{
		compx = (diag1 + diag2) / 2;
		compy = (diag2 - diag1) / 2;
	}
	else
	{
		if (d1)
		{
			int X, Y;
			while (ok(compx, compy))
			{
				++compx;
				++compy;
			}
			--compx;
			--compy;
			X = compx;
			while (ok(compx, compy))
			{
				--compx;
				--compy;
			}
			++compx;
			++compy;
			Y = compy;
			if (arr[X][Y] % 4 == 1)
			{
				while ((X - Y) != diag1)
				{
					--X;
				}
				compx = X;
				compy = Y;
			}
			else
			{
				while ((X - Y) != diag1)
				{
					++Y;
				}
				compx = X;
				compy = Y;
			}
		}
		else
		{
			int X, Y;
			while (ok(compx, compy))
			{
				++compx;
				--compy;
			}
			--compx;
			++compy;
			X = compx;
			while (ok(compx, compy))
			{
				--compx;
				++compy;
			}
			++compx;
			--compy;
			Y = compy;
			if (arr[X][Y] % 4 == 1)
			{
				while ((X + Y) != diag2)
				{
					--X;
				}
				compx = X;
				compy = Y;
			}
			else
			{
				while ((X + Y) != diag2)
				{
					--Y;
				}
				compx = X;
				compy = Y;
			}
		}
		
	}
	cout << compx + 1 << " " << compy + 1 << endl;
	ll x = compx, y = compy;
	ll n1 = y;
	bool br1 = false;
	ll brvert = -1;
	ll brhori = -1;
	ll brv = -1;
	while (n1 > 0) {
		n1--;
		if (arr[x][n1] != 3) {
			if (br1) {
				brhori = x + 1;
				n1 = -1;
			}
			else {
				brv = n1 + 1;
				br1 = true;
			}
		}
	}
	if (brhori == -1) {
		n1 = y;
		while (n1 < m - 1) {
			n1++;
			if (arr[x][n1] != 7) {
				if (br1) {
					brhori = x + 1;
					n1 = m;
				}
				else {
					brv = n1 + 1;
					br1 = true;
				}
			}
		}	
	}
	if (brhori == -1) {
			if (brv == -1) {
				brvert = x + 1;
			}
			else
				brvert = brv;
	}

	if (brvert == -1) {
		if (x > 0) {
			// 0
			for (ll ii = 0; ii < y; ++ii) {
				if (arr[0][ii] < 3 || arr[0][ii] > 5) {
					brvert = ii + 1;
					ii = 12342134213421;
				}
			}
			if (brvert == -1) {
				for (ll ii = y + 1; ii < m; ++ii) {
					if (arr[0][ii] < 5 || arr[0][ii] > 7) {
						brvert = ii + 1;
						ii = 12342134213421;
					}
				}
			}
		}
		else {
			// 1
			for (ll ii = 0; ii < y; ++ii) {
				if (arr[1][ii] < 3 || arr[1][ii] > 5) {
					brvert = ii + 1;
					ii = 12342134213421;
				}
			}
			if (brvert == -1) {
				for (ll ii = y + 1; ii < m; ++ii) {
					if (arr[1][ii] < 5 || arr[1][ii] > 7) {
						brvert = ii + 1;
						ii = 12342134213421;
					}
				}
			}
		}
	}
	else {
		ll n2 = x;
		while (n2 > 0) {
			n2--;
			if (arr[n2][y] != 5) {
				brhori = n2 + 1;
				n2 = -1;
			}
		}
		if (brhori == -1) {
			n2 = x;
			while (n2 < n - 1) {
				n2++;
				if (arr[n2][y] != 1) {
					brhori = n2 + 1;
					n2 = 127842134;
				}
			}
		}	
	}cout << brvert << " " << brhori;
	/*
	int n; cin >> n;
	vector<ll> a(n);
	for (auto& e : a) cin >> e;
	int m = INT_MAX;
	int l = 0;
	ll SUM_ALL = accumulate(all(a), 0);
	ll sum = 0;
	for (int r = 0; r < n; ++r)
	{
		sum += a[r];
		while (sum * 2 >= SUM_ALL)
		{
			//cout << m << " " << l << " " << r << endl;
			m = min(m, r - l + 1);
			sum -= a[l];
			++l;
			
		}
	}
	l = 0;
	sum = 0;
	build(a);
	for (int r = 0; r < n; ++r)
	{
		sum += a[r];
		while ((sum - get(l, r + 1)) * 2 >= SUM_ALL)
		{
			cout << m << " " << l << " " << r << " " << get(l, r + 1) << " " << (sum - get(l, r + 1)) << endl;
			m = min(m, r - l);
			sum -= a[l];
			++l;
		}
	}
	cout << m << endl;
	*/
	
}

/*
3 4
5 6 3 7
3 7 3 7
5 4 3 3
*/

int main()
{
	cin.tie(nullptr)->sync_with_stdio(false);
	int tt = 1;
	//cin >> tt;
	while (tt--)
	{
		solve();
	}
	return 0;
}