#define _USE_MATH_CONSTANTS
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <array>
#include <list>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <utility>
#include <tuple>

#define int long long

using namespace std;

using ll = long long;
using ull = unsigned long long;
using vi = std::vector<int>;
using vvi = std::vector<vi>;
using vb = std::vector<bool>;
using vvb = std::vector<vb>;
using pii = pair<int, int>;


#define all(c) (c).begin(), (c).end()
#define mk make_pair
#define pb push_back

ll euclid(ll a, ll b)
{
	if (a < b)
		swap(a, b);
	if (a % b == 0)
		return b;
	return euclid(a % b, b);
}

template<class _ty>
auto qpow(_ty a, ull pw)
{
	_ty res = 1;
	for (ull _pw = (1ull << 63); _pw > 0; _pw >>= 1)
	{
		res *= res;
		if (_pw & pw)
		{
			res *= a;
		}
	}
	return res;
}

constexpr int maxn = int(2e5);


namespace sgtree
{
	ll tree[maxn * 8];

	constexpr ll NEUTRAL = 10000000000;

	int nn;

	auto combine = [](ll a, ll b) { return min(a, b); };

	void init(const vector<ll>& arr)
	{
		nn = arr.size();
		for (int i = nn; i < nn * 2; ++i)
		{
			tree[i] = arr[i - nn];
		}
	}

	void build(const vector<ll>& arr)
	{
		init(arr);
		for (int i = nn - 1; i >= 1; --i)
		{
			tree[i] = combine(tree[i << 1], tree[i << 1 | 1]);
		}
	}

	/*
	void set(int p)
	{
		for (p += nn; p > 1; p >>= 1)
		{
			tree[p << 1] = combine(tree[p], tree[p ^ 1]);
		}
	}
	*/

	ll get(int l, int r)
	{
		ll res = NEUTRAL;
		for (l += nn, r += nn; r > l; l >>= 1, r >>= 1)
		{
			if (l & 1) res = combine(res, tree[l++]);
			if (r & 1) res = combine(res, tree[--r]);
		}
		return res;
	}
}

using namespace sgtree;

void solve()
{
	ll n; cin >> n;
	vector<ll> a(n);
	for (auto& e : a) cin >> e;
	ll m = n;
	ll l = 0;
	ll SUM_ALL = accumulate(all(a), 0);
	ll sum = 0;
	for (ll r = 0; r < n; ++r)
	{
		sum += a[r];
		while (sum * 2 >= SUM_ALL)
		{
			//cout << m << " " << l << " " << r << endl;
			m = min(m, r - l + 1);
			sum -= a[l];
			++l;

		}
	}
	l = 0;
	sum = 0;
	build(a);
	for (ll r = 0; r < n; ++r)
	{
		sum += a[r];
		while ((sum - get(l, r + 1)) * 2 >= SUM_ALL)
		{
			//cout << m << " " << l << " " << r << " " << get(l, r + 1) << " " << (sum - get(l, r + 1)) << endl;
			m = min(m, r - l);
			sum -= a[l];
			++l;
		}
	}
	cout << m << endl;
	

}

/*
3 4
5 6 3 7
3 7 3 7
5 4 3 3
*/

int main()
{
	cin.tie(nullptr)->sync_with_stdio(false);
	int tt = 1;
	//cin >> tt;
	while (tt--)
	{
		solve();
	}
	return 0;
}