#define _USE_MATH_CONSTANTS
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <array>
#include <list>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <utility>
#include <tuple>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using vi = std::vector<int>;
using vvi = std::vector<vi>;
using vb = std::vector<bool>;
using vvb = std::vector<vb>;
using pii = pair<int, int>;


#define all(c) (c).begin(), (c).end()
#define mk make_pair
#define pb push_back

ll euclid(ll a, ll b)
{
	if (a < b)
		swap(a, b);
	if (a % b == 0)
		return b;
	return euclid(a % b, b);
}

template<class _ty>
auto qpow(_ty a, ull pw)
{
	_ty res = 1;
	for (ull _pw = (1ull << 63); _pw > 0; _pw >>= 1)
	{
		res *= res;
		if (_pw & pw)
		{
			res *= a;
		}
	}
	return res;
}

constexpr int maxn = int(2e5);

/*
namespace sgtree
{
	ll tree[maxn * 2];

	constexpr ll NEUTRAL = 0;

	int nn;

	auto combine = [](ll a, ll b) { return a + b; };

	void init(const vi& arr)
	{
		nn = arr.size();
		for (int i = nn; i < nn * 2; ++i)
		{
			tree[i] = arr[i - nn];
		}
	}

	void build(const vi& arr)
	{
		init(arr);
		for (int i = nn - 1; i >= 0; --i)
		{
			tree[i] = combine(tree[i << 1], tree[i << 1 | 1]);
		}
	}

	void set(int p)
	{
		for (p += nn; p > 1; p >>= 1)
		{
			tree[p << 1] = combine(tree[p], tree[p ^ 1]);
		}
	}

	ll get(int l, int r)
	{
		ll res = NEUTRAL;
		for (l += nn, r += nn; r > l; l >>= 1, r >>= 1)
		{
			if (l & 1) res = combine(res, tree[l++]);
			if (r & 1) res = combine(res, tree[--r]);
		}
		return res;
	}
}

using namespace sgtree;
*/

struct point
{
	long double x, y;


	point(long double x, long double y) : x(x), y(y) {};
	point()
	{
		cin >> x >> y;
	}

	point& operator*=(long double k)
	{
		x *= k;
		y *= k;
		return *this;
	}

	point operator*(long double k)
	{
		auto copy = *this;
		copy *= k;
		return copy;
	}

	point& operator+=(point& o)
	{
		x += o.x;
		y += o.y;
		return *this;

	}

	point& operator-=(point& o)
	{
		x -= o.x;
		y -= o.y;
		return *this;

	}

	point operator+(point& other)
	{
		auto c = *this;
		return c += other;
	}

	point operator-(point& other)
	{
		auto c = *this;
		return c -= other;
	}

	long double norm()
	{
		return std::hypot(x, y);
	}

	point& normalize()
	{
		auto n = norm();
		x /= n;
		y /= n;
		return *this;
	}

	long double cross(point& other)
	{
		return x * other.y - y * other.x;
	}

	long double dot(point& other)
	{
		return x * other.x + y * other.y;
	}
};

constexpr long double eps = 1e-8;

struct seg
{
	point s, f;

	bool contains(point p)
	{
		auto d1 = f - p;
		auto d2 = s - p;
		if (fabs(d1.x / d2.x - d1.y / d2.y) > eps)
		{
			return false;
		}
		return d1.dot(d2) <= 0;
	}

	long double len()
	{
		return (s - f).norm();
	}
};

long double distance(seg& f, seg& s)
{
	std::vector<long double> dists;
	dists.pb((f.f - s.f).norm());
	dists.pb((f.f - s.s).norm());
	dists.pb((f.s - s.f).norm());
	dists.pb((f.s - s.s).norm());

	auto deltaF = f.f - f.s;
	auto deltaS = s.f - s.s;

	point normF = (point(deltaF.y, -deltaF.x)).normalize();
	point normS = (point(deltaS.y, -deltaS.x)).normalize();

	long double a1, b1, c1, a2, b2, c2;

	a1 = deltaF.y;
	b1 = -deltaF.x;
	c1 = -(a1 * f.f.x + b1 * f.f.y);

	a2 = deltaS.y;
	b2 = -deltaS.x;
	c2 = -(a2 * s.f.x + b2 * s.f.y);

	/*
	xa1 + yb1 + c1
	xa2 + yb2 + c2
	y = -(c1 + xa1)/b1
	x(a2-a1b2/b1) + c2 - c1b2/b1 =0;

	*/

	auto xx = (c1 * b2 / b1 - c2) / (a2 - a1 * b2 / b1);
	auto yy = (-c1 - xx * a1) / b1;

	auto sol = point(xx, yy);
	if (f.contains(sol) && a2 * b1 != a1 * b2)
	{
		dists.pb(0);
	}

	auto distToF = [&](point x)
	{
		return (x.x * a1 + x.y * b1 + c1) / hypot(a1, b1);
	};

	auto pbtoF = [&](point x)
	{
		auto d = fabs(distToF(x));
		auto del = normF * d;
		if (f.contains(del + x))
		{
			dists.push_back(d);
		}
		auto del2 = normF * d;
		del2.x = -del2.x;
		del2.y = -del2.y;

		if (f.contains(del2 + x))
		{
			dists.push_back(d);
		}
	};

	pbtoF(s.s);
	pbtoF(s.f);


	auto distToS = [&](point x)
	{
		return (x.x * a2 + x.y * b2 + c2) / hypot(a2, b2);
	};

	auto pbtoS = [&](point x)
	{
		auto d = fabs(distToS(x));
		auto del = normS * d;
		if (s.contains(del + x))
		{
			dists.push_back(d);
		}
		auto del2 = normF * d;
		del2.x = -del2.x;
		del2.y = -del2.y;

		if (s.contains(del2 + x))
		{
			dists.push_back(d);
		}
	};

	pbtoS(f.s);
	pbtoS(f.f);

	auto m = dists[0];
	for (auto d : dists)
	{
		if (d < m)
		{
			m = d;
		}
	}

	return m;
}

void solve()
{
	int n;
	cin >> n;
	vector<seg> segs(n);


	long long answ = 0;
	for (int i = 0; i < n; ++i)
	{
		for (int j = i + 1; j < n; ++j)
		{
			std::cout << i << " " << j << " " << distance(segs[i], segs[j]) << endl;
			for (int k = j + 1; k < n; ++k)
			{
				auto d1 = distance(segs[i], segs[j]);
				auto d2 = distance(segs[k], segs[j]);
				auto d3 = distance(segs[i], segs[k]);

				if (d1 - segs[k].len() < eps || d2 - segs[i].len() < eps || d3 - segs[i].len() < eps)
				{
					++answ;
				}
			}
		}
	}
	std::cout << answ;
}

/*
4
1 1 2 3
1 3 2 1
3 1 4 3
2 6 3 6
*/

int main()
{
	cin.tie(nullptr)->sync_with_stdio(false);
	int tt = 1;
	//cin >> tt;
	while (tt--)
	{
		solve();
	}
	return 0;
}