#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
ll inf = 1e18;
int NEUTRAL = inf;

ll calc(ll a, ll b) {
    return min(a, b);
}

struct segment_tree{
    int n, maxn;
    vector<ll> tree;

    segment_tree(vector<ll> a) {
        n = (int) a.size();
        maxn = (int) (1ll << (int) ceil(log2(n)));
        tree.resize(2 * maxn, NEUTRAL);
        for (int i =  maxn - 1; i < maxn - 1 + n; ++i) {
            tree[i] = a[i - maxn + 1];
        }
        for (int i = maxn - 2; i >= 0; --i) {
            tree[i] = calc(tree[i * 2 + 1], tree[i * 2 + 2]);
        }
    }

    ll getobj(int l, int r) {
        return getobj(0, 0, maxn, l, r);
    }

private:
    ll getobj(int v, int cl, int cr, int l, int r) {
        if (cr <= l || r <= cl) {
            return inf;
        }
        if (l <= cl && cr <= r) {
            return tree[v];
        }
        int tm = (cr + cl) / 2;
        return calc(getobj(v * 2 + 1, cl, tm, l, r), getobj(v * 2 + 2, tm, cr, l, r));
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    ll s = 0;
    vector<ll> a(n), pref(n + 1);
    cin >> a[0];
    s += a[0];
    for (int i = 1; i < n; ++i) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
        s += a[i];
    }
    int l = 0, r = n;
    segment_tree tr = segment_tree(a);
    ll need = s / 2;
    need += s % 2;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        ll maxnow = 0;
        for (int i = 0; i < n - m; ++i) {
            maxnow = max(maxnow, pref[i + m] - pref[i]);
            maxnow = max(maxnow, pref[i + m + 1] - pref[i] - tr.getobj(i, i + m + 1));
        }
        maxnow = max(maxnow, pref[n] - pref[n - m]);
        if (maxnow < need) {
            l = m;
        } else {
            r = m;
        }
    }
    cout << r;
}
