#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

struct node {
    map<char, node *> children;
    bool terminal = false;
    int count = 0, depth = 0;

    bool exists(char c) {
        return children.find(c) != children.end();
    }

} *root;

struct trie {
    node *root = new node;

    void add(string s) {
        node *cur = root;
        root->count++;
        for (char &c: s) {
            if (!cur->exists(c)) {
                node *n = new node;
                cur->children[c] = n;
                n->depth = cur->depth + 1;
            }
            cur = cur->children[c];
            cur->count++;
        }
        cur->terminal = true;
    }

    void print(node *cur) {
        string space;
        for (int i = 0; i < cur->depth; i++) {
            space += "  ";
        }
        cout << space << "depth: " << cur->depth << '\n';
        cout << space << "count: " << cur->count << '\n';
        cout << space << "terminal: " << cur->terminal << '\n';
        cout << space << "children: {" << '\n';
        for (auto &i: cur->children) {
            cout << space + "  " << i.first << "-> " << i.second << '\n';
            print(i.second);
        }
        cout << space << "}\n";
    }

    int maxdep(int n) {
        valid.assign(n + 1, true);
        dfs(root);
        int k = 0;
        for (; k <= n; k++) {
            if (!valid[k]) {
                return k - 1;
            }
        }
        return k - 1;
    }

private:
    vector<bool> valid;

    void dfs(node *cur) {
        if (cur->count % 2 != 0) {
            valid[cur->depth] = false;
        }
        for (auto &u: cur->children) {
            dfs(u.second);
        }
    }
};

int main() {
    int n, size;
    cin >> n;
    trie tr;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        size = s.size();
        tr.add(s);
    }
//    tr.print(tr.root);
    cout << tr.maxdep(size);
}
