#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

ld eps = 1e-8;

bool eq(ld a, ld b) {
    return fabs(a - b) <= eps;
}

struct Point{
    ld x, y;

    Point() {
        x = 0;
        y = 0;
    }

    Point(ld x, ld y) : x(x), y(y) {}

    Point operator-(Point b) {
        return {x - b.x, y - b.y};
    }
};

ld scalar(Point a, Point b) {
    return a.x * b.x + a.y + b.y;
}

ld vectorn(Point a, Point b) {
    return a.x * b.y - a.y * b.x;
}

ld rast(Point a, Point b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

ld point_to_line(Point a, Point b, Point c) {
    return fabs(vectorn(b - a, c - a)) / (2.0 * rast(b, c));
}

ld point_to_seg(Point a, Point b, Point c) {
    if (scalar(c - b, a - b) > 0 && scalar(b - c, a - c) > 0) {
        return point_to_line(a, b, c);
    }
    return min(rast(a, b), rast(a, c));
}


ld seg_to_seg(Point a, Point b, Point c, Point d) {
    if (vectorn(c - a, b - a) * vectorn(b - a, d - a) > 0 && (vectorn(b - c, d - c) * vectorn(d - c, a - c) > 0)) {
        return 0;
    }
    if (eq(vectorn(c - a, b - a), 0) && eq(vectorn(b - c, a - c), 0)) {
        return 0;
    }
    if (eq(vectorn(d - a, b - a), 0) && eq(vectorn(b - d, a - d), 0)) {
        return 0;
    }
    return min(point_to_seg(a, c, d), point_to_seg(b, c, d));
}

int main() {
    int m;
    cin >> m;
    vector<pair<Point, Point>> a(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i].first.x >> a[i].first.y >> a[i].second.x >> a[i].second.y;
    }
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        for (int j = i + 1; j < m; ++j) {
            for (int k = j + 1; k < m; ++k) {
                bool t = false;
                ld l1, l2;
                l1 = rast(a[i].first, a[i].second);
                l2 = seg_to_seg(a[j].first, a[j].second, a[k].first, a[k].second);
                if (l1 >= l2 || eq(l1, l2)) {
                    t = true;
                }
                l1 = rast(a[j].first, a[j].second);
                l2 = seg_to_seg(a[i].first, a[i].second, a[k].first, a[k].second);
                if (l1 >= l2 || eq(l1, l2)) {
                    t = true;
                }
                l1 = rast(a[k].first, a[k].second);
                l2 = seg_to_seg(a[j].first, a[j].second, a[i].first, a[i].second);
                if (l1 >= l2 || eq(l1, l2)) {
                    t = true;
                }
                if (t) {
                    ++ans;
                }
            }
        }
    }
    cout << ans;
    return 0;
}