#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define int int64_t

using namespace std;

class Tree {
public:
    struct node {
        int val;
        node *l, *r;
        node() : val(0), l(nullptr), r(nullptr) {}
        void upd() {
            val = min(l ? l->val : 1e18, r ? r->val : 1e18);
        }
    };
    void set(int h, int x) {
        set(root, 0, SIZE, h, x);
    }
    int sum(int l, int r) {
        return sum(root, 0, SIZE, l, r);
    }

private:
    node *root = nullptr;
    int SIZE = (1 << 20);

    void set(node *&t, int l, int r, int h, int s) {
        if (!t)
            t = new node();
        if (l + 1 == r) {
            t->val = s;
            return;
        }
        int u = (l + r) >> 1;
        if (u <= h)
            set(t->r, u, r, h, s);
        else
            set(t->l, l, u, h, s);
        t->upd();
    }

    int sum(node *t, int l, int r, int hl, int hr) {
        if (!t || r <= hl || hr <= l)
            return 1e18;
        if (hl <= l && r <= hr)
            return t->val;
        int u = (l + r) >> 1;
        return min(sum(t->l, l, u, hl, hr), sum(t->r, u, r, hl, hr));
    }
};

void solve() {
    int n, sum = 0, res = 1e18;
    cin >> n;
    Tree t;
    vector<int> f(n), h(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> f[i];
        h[i + 1] = h[i] + f[i];
        t.set(i, f[i]);
    }
    sum = (h[n] + 1) >> 1;
    for (int i = 0; i < n && sum <= h[n] - h[i]; i++) {
        int lo = i, hi = n + 1;
        while (lo + 1 < hi) {
            int u = (lo + hi) >> 1, s = h[u] - h[i];
            if (sum <= s)
                hi = u;
            else
                lo = u;
        }
        if (sum <= h[hi] - h[i] - t.sum(i, hi))
            hi--;
        res = min(res, hi - i);
//        cout << h[hi] << ' ' << h[i] << ' ' << t.sum(i, hi) << '\n';
//        cout << res << '\n';
    }
    cout << res;
}

int32_t main() {
#ifdef BIBIKOV
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif

    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }

    return 0;
}
