#include <iostream>
#include <vector>
#include <map>

#define int int64_t

using namespace std;

int mod = 1e9 + 7, p = 239;
vector<int> pp;

void init() {
    pp.resize(2e6 + 1);
    for (int i = 0; i < 2e6; i++)
        pp[i + 1] = pp[i] * p % mod;
}

class Hash {
public:
    Hash(string s) : h(s.size() + 1) {
        for (int i = 0; i < s.size(); i++)
            h[i + 1] = h[i] * p + s[i];
    }

    int operator()(int l, int r) {
        int res = (h[r] - h[l] * pp[r - l] % mod + mod) % mod;
        return res;
    }

private:
    vector<int> h;
};

void solve() {
    int n, sz;
    cin >> n;
    vector<Hash> h;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        sz = (int) s.size() + 1;
        h.push_back(s);
    }

    int lo = 0, hi = sz;
    while (lo + 1 < hi) {
        int len = (lo + hi) >> 1;
        map<int, bool> m;
        for (int i = 0; i < n; i++)
            m[h[i](0, len)] ^= 1;
        int s = 0;
        for (auto [a, sum] : m)
            s += sum;
        if (s == 0)
            lo = len;
        else
            hi = len;
    }
    cout << lo;
}

int32_t main() {
#ifdef BIBIKOV
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif

    init();

    int tt = 1;
//    cin >> tt;
    while (tt--)
        solve();

    return 0;
}
