#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>

using namespace std;

#define vec vector
#define forn(i, n) for(int i = 0; i < n; i++)


typedef long long ll;

struct pnt {
	double x, y;
	pnt(double xs, double ys) {
		x = xs;
		y = ys;
	}
};

double operator %(const pnt& a, const pnt& b) {
	return a.x * b.y - a.y * b.x;
}

double operator *(const pnt& a, const pnt& b) {
	return a.x * b.x + a.y * b.y;
}

pnt operator -(const pnt& a, const pnt& b) {
	return pnt(a.x - b.x, a.y - b.y);
}

pnt operator +(const pnt& a, const pnt& b) {
	return pnt(a.x + b.x, a.y + b.y);
}

double spnt(pnt a, pnt b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

double s(pnt a, pnt b, pnt c) {
	if ((a - b) * (c - b) < 0) return spnt(a, b);
	if ((a - c) * (b - c) < 0) return spnt(a, c);
	return (((c - a) % (b - a)) * ((c - a) % (b - a))) / spnt(b, c);
}

double s1(pair<pnt, pnt> a, pair<pnt, pnt> b) {
	double ret = 1e9;

	ret = min(ret, s(a.first, b.first, b.second));
	ret = min(ret, s(a.second, b.first, b.second));
	ret = min(ret, s(b.first, a.first, a.second));
	ret = min(ret, s(b.second, a.first, a.second));
	//cout << ret << "\n";
	return ret;
}

bool isgood(pair<pnt, pnt> a, pair<pnt, pnt> b, pair<pnt, pnt> c) {
	bool ret = 0;

	ret |= s1(a, b) <= spnt(c.first, c.second);
	ret |= s1(a, c) <= spnt(b.first, b.second);
	ret |= s1(c, b) <= spnt(a.first, a.second);

	return ret;
}

void solve() {
	int m;
	double x1, y1, x2, y2;
	cin >> m;

	vector <pair<pnt, pnt>> p;
	for (int i = 0; i < m; i++) {
		cin >> x1 >> y1 >> x2 >> y2;

		p.push_back({ pnt(x1, y1), pnt(x2, y2) });
	}

	//isgood(p[0], p[2], p[3]);
	
	int ans = 0;
	for (int i = 0; i < m; i++) {
		for (int j = i + 1; j < m; j++) {
			for (int k = j + 1; k < m; k++) {


				if (isgood(p[i], p[j], p[k])) {
					//cout << i << ' ' << j << ' ' << k << "\n";
					ans++;
				}

			}
		}
	}
	
	cout << ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
	return 0;
}