#include <bits/stdc++.h>

using namespace std;
#define ld double
#define ll long long

struct point {
    ld x, y;

    point() = default;

    point(ld x, ld y) : x(x), y(y) {}

};

struct vec {
    ld x, y;

    vec(ld x, ld y) : x(x), y(y) {}

    vec(point x, point y) : x(y.x - x.x), y(y.y - x.y) {}
};

ld cross_prod(vec a, vec b) {
    return a.x * b.y - a.y * b.x;
}

ld dot_prod(vec a, vec b) {
    return a.x * b.x + a.y * b.y;
}

istream &operator>>(istream &in, point &a) {
    in >> a.x >> a.y;
    return in;
}

ld dist(point a, point b) {
    return ((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

ld dist(point x, point a, point b) {
    if (dot_prod(vec(a, b), vec(a, x)) <= 0) return dist(a, x);
    if (dot_prod(vec(b, a), vec(b, x)) <= 0) return dist(b, x);
    return (abs(cross_prod(vec(a, b), vec(a, x))) / dist(a, b)) * (abs(cross_prod(vec(a, b), vec(a, x))) / dist(a, b));
}

ld dist(pair<point, point> &s1, pair<point, point> &s2) {
    auto [a, b] = s1;
    auto [c, d] = s2;
    if (cross_prod(vec(a, b), vec(a, c)) * cross_prod(vec(a, b), vec(a, d)) <= 0) {
        if (cross_prod(vec(c, d), vec(c, a)) * cross_prod(vec(c, d), vec(c, b)) <= 0) {
            return 0.0;
        }
    }
    return min({dist(a, c, d), dist(b, c, d), dist(c, a, b), dist(d, a, b)});
}

ld len(pair<point, point> s) {
    return sqrt(
            (s.second.x - s.first.x) * (s.second.x - s.first.x) + (s.second.y - s.first.y) * (s.second.y - s.first.y));
}

void solve() {
    ll ans = 0;
    int n;
    cin >> n;
    vector<pair<point, point>> segments(n);
    for (int i = 0; i < n; i++) {
        cin >> segments[i].first >> segments[i].second;
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            for (int k = j +
                         1; k < n; k++) {
                bool flag = false;
                if (dist(segments[i], segments[j]) <= len(segments[k])) {
                    flag = true;
                }
                if (dist(segments[i], segments[k]) <= len(segments[j])) {

                    flag = true;
                }
                if (dist(segments[j], segments[k]) <= len(segments[i])) {
                    flag = true;
                }
                ans += flag;
            }
        }
    }
    cout << ans;
}

signed main() {
    int t = 1;
//    cin >> t;
    while (t--) solve();
}
