#include<bits/stdc++.h>

using namespace std;
#define int long long
typedef long double ld;
#define pb push_back

const ld EPS = 1e-11;

struct v2d {
    ld x, y;

    v2d(ld x, ld y) : x(x), y(y) {}

    v2d operator-(v2d b) {
        return {x - b.x, y - b.y};
    }

    ld operator*(v2d b) {
        return x * b.x + y * b.y;
    }

    v2d operator*(ld b) {
        return {x * b, y * b};
    }

    v2d operator-() {
        return {-x, -y};
    }

    ld operator^(v2d b) {
        return x * b.y - b.x * y;
    }

    v2d operator+(v2d b) {
        return {x + b.x, y + b.y};
    }

    ld sq() {
        return x * x + y * y;
    }
};


bool is_parallel(v2d a1, v2d b1, v2d a2, v2d b2) {
    v2d v1 = b1 - a1;
    v2d v2 = b2 - a2;
    return abs(v1.x * v2.y - v2.x + v1.y) <= EPS;
}


v2d intersect_lines(v2d a, v2d b, v2d c, v2d d) {
    v2d v1 = b - a;
    v2d n1 = {v1.y, -v1.x};
    ld c1 = -n1 * a;
    v2d v2 = c - d;
    v2d n2 = {v2.y, -v2.x};
    ld c2 = -n2 * c;
    ld y = (-c2 + n1.x + c1 * n2.x) / (n1.x * n2.y - n2.x * n1.y);
    ld x = (-c2 + n1.y + c1 * n2.y) / (-n1.x * n2.y + n2.x * n1.y);
    return {x, y};
}

bool point_on_line(v2d p, v2d a, v2d b) {
    return abs((p - a) ^ (p - b)) <= EPS;
}


bool point_in_segment(v2d p, v2d a, v2d b) {
    if (!point_on_line(p, a, b)) return false;
    return (p - a) * (p - b) <= 0;
}


v2d vtl(v2d p, v2d a, v2d b) {
    v2d v = (b - a);
    v2d n = {v.y, -v.x};
    return n * (((a - p) * n) / n.sq());
}

ld dist(v2d a, v2d b) {
    return sqrtl((a - b).sq());
}

//ld dist_point_segment(v2d p, v2d a, v2d b) {
//    v2d t = vtl(p, a, b);
//    v2d lp = p + t;
//    if (point_in_segment(lp, a, b)) return sqrtl(t.sq());
//    return min()
//}
//
//
//ld dist_segments(v2d a, v2d b, v2d c, v2d d) {
//    if (!is_parallel(a, b, c, d)) {
//        v2d p = intersect_lines(a, b, c, d);
//        if (point_in_segment(p, a, b) && point_in_segment(p, c, d)) return 0;
//    }
//    return min({
//
//               })
//}

unordered_map <int, int> mp;

void solve() {
    int q, c;
    cin >> q >> c;
    while (q--) {
        int t, c2;
        cin >> t;
        if (t == 1) {
            cin >> c2;
            string s;
            cin >> s;
            int temp = 0;
            for (int i = 0; i < s.size(); i++) {
                if (s[i] == 'L') {
                    temp *= 2;
                    temp += 1;
                }
                else {
                    temp *= 2;
                    temp += 2;
                }
            }
            mp[temp] = c2;
        }
        else {
            string s;
            cin >> s;
            int temp = 0;
            int color = -1;
            for (int i = 0; i < s.size(); i++) {
                if (s[i] == 'L') {
                    temp *= 2;
                    temp += 1;
                }
                else {
                    temp *= 2;
                    temp += 2;
                }
                if (mp[temp]) {
                    color = mp[temp];
                }
                else if (color != -1) {
                    if (s[i] == 'L') {
                        color++;
                        color %= c;
                    }
                    else {
                        color--;
                        color += c;
                        color %= c;
                    }
                }
            }
            cout << color << '\n';
        }
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        //cout << '\n';
    }
}